(function() {

	var pages = _.Query.all(document.body, '.eFlipper');
		
	for (var i = 0, f; f = pages[i]; i++) { 
	
		if (!_.Node.first(f)) continue;
			
		var
			controls = _.dataGet(f, 'eFlipControls', true),
			flipFrame = _.make('div.eFlipFrame'),
			flipControls = _.make('div.eFlipControls'),
			pagination = hasControl('pages');
			
		function hasControl(v) { 
			return controls && (
				(controls.indexOf(v) >= 0) ||
				(controls.indexOf('all') >= 0)
			);
		}
		
		if (f.flipDelay = _.dataGet(f, 'eFlipDelay')) {
			f.flipDelay = Math.floor(f.flipDelay * 1000 / 33);
		} else f.flipDelay = 151;
		f.fliptimer = f.flipDelay;

		f.flipTick = function() {
			if (!_.Class.exists(this, 'eFlipPaused') && !(--this.flipTimer)) {
				(
					_.Node.next(this.flipCurrent) ||
					_.Node.first(this.flipCurrent.parentNode)
				).flipSet();
			}
			var fp = this.flipProgress;
			if (fp.bar) fp.bar.style.width = 100 - (Math.floor(
				(this.flipTimer * 10000) / this.flipDelay
			) / 100) + '%';
			if (fp.timer) {
				fp.timer.style.webkitTransform = fp.timer.style.transform = 'rotate(' + (
					360 - this.flipTimer * 360 / this.flipDelay
				) + 'deg)';
			}
		}

		f.flipChangePause = function() {
			if (
				this.flipPauseOnChange &&
				!_.Class.exists(this, 'eFlipPaused')
			) _.Class.toggle(this, 'eFlipPaused');
		}

		_.Class.add(f, 'eFlipperLive');
		
		flipControls.addControl = function(name, handler) {
			return _.make('a.eFlipControl' + name, {
				last : this,
				onclick : handler
			});
		}

		f.flipPauseOnChange = _.dataGet(f, 'eFlipPauseOnChange');

		if (hasControl('forwardBack')) flipControls.addControl('Back', function(e) {
			_.Event.prevent(e);
			var p = e.target.parentNode.parentNode;
			(
				_.Node.prev(p.flipCurrent) ||
				_.Node.last(p.flipCurrent.parentNode)
			).flipSet();
			p.flipChangePause();
		});

		while (e = f.firstChild) {
			f.removeChild(e);
			if (e.nodeType == 1) {
				flipFrame.appendChild(e);
				_.Class.add(e, 'eFlipSlide');
				e.flipSet = function() {
					var p = this.parentNode.parentNode;
					if (p.flipLast) _.Class.remove(p.flipLast, 'eFlipLast');
					if (p.flipCurrent) {
						var l = p.flipLast = p.flipCurrent;
						_.Class.swap(l, 'eFlipCurrent','eFlipLast');
						if (l.flipControl) _.Class.remove(l.flipControl, 'eFlipControlCurrent');
					}
					p.flipCurrent = this;
					_.Class.add(this, 'eFlipCurrent');
					if (this.flipControl) _.Class.add(this.flipControl, 'eFlipControlCurrent');
					p.flipTimer = p.flipDelay;
				}
				if (pagination) {
					e.flipControl = flipControls.addControl('Page', function(e) {
					_.Event.prevent(e);
						e.target.flipTarget.flipSet();
						e.target.parentNode.parentNode.flipChangePause();
					});
					e.flipControl.flipTarget = e;
				}
			}
		}
		
		if (hasControl('pausePlay')) flipControls.addControl(
			'PausePlay', function(e) {
				_.Event.prevent(e);
				_.Class.toggle(e.currentTarget.parentNode.parentNode, 'eFlipPaused');
				console.log(e.target, e.currentTarget);
			}
		);

		if (hasControl('forwardBack')) flipControls.addControl(
			'Forward', function(e) {
				_.Event.prevent(e);
				var p = e.target.parentNode.parentNode;
				(
					_.Node.next(p.flipCurrent) ||
					_.Node.first(p.flipCurrent.parentNode)
				).flipSet();
				p.flipChangePause();
			}
		);

		f.flipProgress = {};

		if (hasControl('progressTimer'))
			f.flipProgress.timer = _.make('span.eFlipProgressTimer', { last : flipControls});
		if (hasControl('progressBar'))
			f.flipProgress.bar = _.make('span', { last : _.make(
				'span.eFlipProgressBar', { last : flipControls }
			)});

		f.appendChild(flipFrame);
		f.appendChild(flipControls);
		flipFrame.firstChild.flipSet();

	}
	
	_.Event.add(window, 'load', function(e) {
		setInterval( function() {
			for (var i = 0, f; f = pages[i]; i++) f.flipTick();
		}, 33);
	});

	_.Load.style('eFlipper.screen.css', 'screen,projection,tv');

})();